<template>
	<div>
	<el-select v-if="!cargaManual" v-model="CalleObject"  value-key="nombre" 
		:disabled="disabled"
		:placeholder="placeholder" filterable default-first-option >
		<template>
			<el-option-group v-if="frecuentes" label="Frecuentes">
				<el-option 
					v-for="item in listaFrecuentes"
					:key="`${item.nombre}-${item.localidad}`" :label="`${item.nombre}`"
					:value="{...item}">
					<span>{{item.nombre}}, {{item.localidad}}</span>
				</el-option>
			</el-option-group>
			<el-option-group v-if="lugares" label="Lugares">
				<el-option 
					v-for="item in listaLugares"
					:key="`${item.nombre}-${item.localidad}`" :label="`${item.nombre}`"
					:value="{...item}">
					<span>{{item.nombre}}, {{item.localidad}}</span>
				</el-option>
			</el-option-group>
			<el-option-group v-if="calles" label="Calles">
				<el-option
					v-for="item in listaCalles"
					:key="`${item.nombre}-${item.localidad}`"
					value-key="nombre" :label="`${item.nombre}`"
					:value="{...item}">
					<span>{{item.nombre}}, {{item.localidad}}</span>
				</el-option>
			</el-option-group>
		</template>
		<template slot="empty">
			<span></span>
				<el-button size="mini" @click="cargaManual = true">Agregar</el-button>
		</template>
	</el-select>
		<el-input v-else
		v-model="CalleStr"
		:placeholder="placeholder"
		:disabled="disabled"

	>
		<el-select v-model="tipoOrigen" slot="prepend" :placeholder="placeholder" 
			class="select-prepend" default-first-option>
			<el-option v-if="lugares" label="Lugar" value="Lugar"></el-option>
			<el-option v-if="calles" label="Calle" value="Calle"></el-option>
		</el-select>
	</el-input>
	</div>
</template>
<script>
import {Rest} from '@/../vendor/mind-core-web/'
import storeLugares from '@/store/lugares'
export default {
	props: {
		value: String,
		lugares: Boolean,
		calles: Boolean,
		frecuentes: Boolean,
		placeholder: String,
		/** Indica que sólo se debe cargar la lista de calles si no fue cargada antes */
		lazy: Boolean, 
		disabled: Boolean,
	},
	created() {
		this.apiLugares = new Rest({
			uri: `/api/viajes/agencias/1/lugares`, 
			state: storeLugares.data,
			key: 'id'})
			if(storeLugares.data.RESOURCE_LIST.length == 0) {
				this.fetchLugares()
			}

	},
	computed: {
		CalleObject: {
			get(){
				return {nombre: this.value}
			},
			set(v) {
				this.$emit('input',v.nombre)
				this.$emit('change',v.nombre)
				this.$emit('select',v)
			}
		},
		CalleStr: {
			get(){
				return this.value
			},
			set(v) {
				this.$emit('input',v)
				this.$emit('change',v)
				this.$emit('select',{nombre: v, tipo: this.tipoOrigen})
			}
		},

		listaLugares() {
			return storeLugares.data.RESOURCE_LIST.filter(l=>l.tipo == 'Lugar' && !l.frecuente)
		},
		listaCalles() {
			return storeLugares.data.RESOURCE_LIST.filter(l=>l.tipo == 'Calle' && !l.frecuente)
		},
		listaFrecuentes() {
			return storeLugares.data.RESOURCE_LIST.filter(l=>l.frecuente)
		},
	},
	methods: {
		async fetchLugares() {
			if(storeLugares.data.RESOURCE_LIST.length>0 && this.lazy) {
				return
			}
			let tipos = []
			if(this.lugares) {
				tipos.push('Lugar')
			}
			if(this.calles) {
				tipos.push('Calle')
			}

			this.apiLugares.FetchAll({
				filters: {
					tipo: tipos
				},
				sort: ['tipo','nombre']
			}).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
		},
	},
	data() {
		return {
			cargaManual: false,
			tipoOrigen: 'Calle',
		}
	}
	
}
</script>
<style scoped>
.select-prepend {
	width: 90px;
}

</style>